import React, {useState, useEffect, useRef} from 'react';
import List from '@mui/material/List';
import Box from '@mui/material/Box';

import {Link} from 'react-router-dom'

import { FloatBtn, ChatAvatar } from "../components"
import { connect }  from 'react-redux'


const Chat = ({ chat, currChat }) => {

  const [msgText, setMsgText] = useState( chat.messages && chat.messages[0]?.text || 'нема')

  // const {_id, title, owner, members, messages} = chat
  // const { text, owner: msgOwner, media, createdAt } = messages

  useEffect(() => {
    setMsgText( chat.messages && chat.messages[0]?.text || '...')
  }, [chat])

  return (
    <Link 
      style={{ textDecoration: 'none' }}
      to={`/main/${chat._id}`}
      >
     
      <div
        className={`chatItem ${currChat ? "selectedChat" : "notSelectedChat"} `}
        >
        <div className={"chatAvatar"}>
          <ChatAvatar chat={chat} />
        </div>   

        <div className={"chatBody"}>

          <div className={"chatTitle"}>

            <div className={"chatName"}>
              {chat.title} 
            </div> 

            <div className={"chatStatus"}>
      
            </div> 
          </div> 

          <div className={"chatSubTitle"}>

            <div className={"chatText"}>
              {msgText}
            </div> 

            <div className={"chatMsgCount"}>
            
            </div> 
          </div> 

        </div>
              
      </div>
    </Link>
  )
}

const ChatList = ({ chats=[], currChatId }) => {

  // const [chatsInput, setChats] = useState(chats)
  // useEffect(() => {
  //   setChats(chats)
  // }, [chats])

  return (
      <div        
        sx={{ maxWidth: '100%', bgcolor: 'background.paper', position: 'relative', zIndex: 2, }}
        >
          <div>
            <Box sx={{  position: 'fixed', top: '90%', left: '25%', zIndex: 10}} >
              <FloatBtn />
            </Box>
              {chats.map(chat =>          
                    <Chat key={chat._id} chat={chat} currChat={currChatId === chat._id} /> 
              )}  
          </div>  
        </div>

    
      
  )
}
export const CChatList = connect( state => ({ chats: Object.values(state.chats).filter(el => !!el._id)}))(ChatList)

